diff --git a/lib/lacp.c b/lib/lacp.c
index 8353746be169..d6b36aa3d587 100644
--- a/lib/lacp.c
+++ b/lib/lacp.c
@@ -912,15 +912,15 @@ lacp_print_details(struct ds *ds, struct lacp *lacp) OVS_REQUIRES(mutex)
     int i;
 
     ds_put_format(ds, "---- %s ----\n", lacp->name);
-    ds_put_format(ds, "\tstatus: %s", lacp->active ? "active" : "passive");
+    ds_put_format(ds, "  status: %s", lacp->active ? "active" : "passive");
     if (lacp->negotiated) {
         ds_put_cstr(ds, " negotiated");
     }
     ds_put_cstr(ds, "\n");
 
-    ds_put_format(ds, "\tsys_id: " ETH_ADDR_FMT "\n", ETH_ADDR_ARGS(lacp->sys_id));
-    ds_put_format(ds, "\tsys_priority: %u\n", lacp->sys_priority);
-    ds_put_cstr(ds, "\taggregation key: ");
+    ds_put_format(ds, "  sys_id: " ETH_ADDR_FMT "\n", ETH_ADDR_ARGS(lacp->sys_id));
+    ds_put_format(ds, "  sys_priority: %u\n", lacp->sys_priority);
+    ds_put_cstr(ds, "  aggregation key: ");
     if (lacp->key_slave) {
         ds_put_format(ds, "%u", lacp->key_slave->key
                                 ? lacp->key_slave->key
@@ -930,7 +930,7 @@ lacp_print_details(struct ds *ds, struct lacp *lacp) OVS_REQUIRES(mutex)
     }
     ds_put_cstr(ds, "\n");
 
-    ds_put_cstr(ds, "\tlacp_time: ");
+    ds_put_cstr(ds, "  lacp_time: ");
     if (lacp->fast) {
         ds_put_cstr(ds, "fast\n");
     } else {
@@ -964,36 +964,36 @@ lacp_print_details(struct ds *ds, struct lacp *lacp) OVS_REQUIRES(mutex)
 
         ds_put_format(ds, "\nslave: %s: %s %s\n", slave->name, status,
                       slave->attached ? "attached" : "detached");
-        ds_put_format(ds, "\tport_id: %u\n", slave->port_id);
-        ds_put_format(ds, "\tport_priority: %u\n", slave->port_priority);
-        ds_put_format(ds, "\tmay_enable: %s\n", (slave_may_enable__(slave)
+        ds_put_format(ds, "  port_id: %u\n", slave->port_id);
+        ds_put_format(ds, "  port_priority: %u\n", slave->port_priority);
+        ds_put_format(ds, "  may_enable: %s\n", (slave_may_enable__(slave)
                                                  ? "true" : "false"));
 
-        ds_put_format(ds, "\n\tactor sys_id: " ETH_ADDR_FMT "\n",
+        ds_put_format(ds, "\n  actor sys_id: " ETH_ADDR_FMT "\n",
                       ETH_ADDR_ARGS(actor.sys_id));
-        ds_put_format(ds, "\tactor sys_priority: %u\n",
+        ds_put_format(ds, "  actor sys_priority: %u\n",
                       ntohs(actor.sys_priority));
-        ds_put_format(ds, "\tactor port_id: %u\n",
+        ds_put_format(ds, "  actor port_id: %u\n",
                       ntohs(actor.port_id));
-        ds_put_format(ds, "\tactor port_priority: %u\n",
+        ds_put_format(ds, "  actor port_priority: %u\n",
                       ntohs(actor.port_priority));
-        ds_put_format(ds, "\tactor key: %u\n",
+        ds_put_format(ds, "  actor key: %u\n",
                       ntohs(actor.key));
-        ds_put_cstr(ds, "\tactor state:");
+        ds_put_cstr(ds, "  actor state:");
         ds_put_lacp_state(ds, actor.state);
         ds_put_cstr(ds, "\n\n");
 
-        ds_put_format(ds, "\tpartner sys_id: " ETH_ADDR_FMT "\n",
+        ds_put_format(ds, "  partner sys_id: " ETH_ADDR_FMT "\n",
                       ETH_ADDR_ARGS(slave->partner.sys_id));
-        ds_put_format(ds, "\tpartner sys_priority: %u\n",
+        ds_put_format(ds, "  partner sys_priority: %u\n",
                       ntohs(slave->partner.sys_priority));
-        ds_put_format(ds, "\tpartner port_id: %u\n",
+        ds_put_format(ds, "  partner port_id: %u\n",
                       ntohs(slave->partner.port_id));
-        ds_put_format(ds, "\tpartner port_priority: %u\n",
+        ds_put_format(ds, "  partner port_priority: %u\n",
                       ntohs(slave->partner.port_priority));
-        ds_put_format(ds, "\tpartner key: %u\n",
+        ds_put_format(ds, "  partner key: %u\n",
                       ntohs(slave->partner.key));
-        ds_put_cstr(ds, "\tpartner state:");
+        ds_put_cstr(ds, "  partner state:");
         ds_put_lacp_state(ds, slave->partner.state);
         ds_put_cstr(ds, "\n");
     }
@@ -1021,14 +1021,14 @@ lacp_print_stats(struct ds *ds, struct lacp *lacp) OVS_REQUIRES(mutex)
     for (i = 0; i < shash_count(&slave_shash); i++) {
         slave = sorted_slaves[i]->data;
         ds_put_format(ds, "\nslave: %s:\n", slave->name);
-        ds_put_format(ds, "\tRX PDUs: %u\n", slave->count_rx_pdus);
-        ds_put_format(ds, "\tRX Bad PDUs: %u\n", slave->count_rx_pdus_bad);
-        ds_put_format(ds, "\tTX PDUs: %u\n", slave->count_tx_pdus);
-        ds_put_format(ds, "\tLink Expired: %u\n",
+        ds_put_format(ds, "  RX PDUs: %u\n", slave->count_rx_pdus);
+        ds_put_format(ds, "  RX Bad PDUs: %u\n", slave->count_rx_pdus_bad);
+        ds_put_format(ds, "  TX PDUs: %u\n", slave->count_tx_pdus);
+        ds_put_format(ds, "  Link Expired: %u\n",
                       slave->count_link_expired);
-        ds_put_format(ds, "\tLink Defaulted: %u\n",
+        ds_put_format(ds, "  Link Defaulted: %u\n",
                       slave->count_link_defaulted);
-        ds_put_format(ds, "\tCarrier Status Changed: %u\n",
+        ds_put_format(ds, "  Carrier Status Changed: %u\n",
                       slave->count_carrier_changed);
     }
 
@@ -1108,35 +1108,35 @@ lacp_get_slave_stats(const struct lacp *lacp, const void *slave_, struct lacp_sl
 
     slave = slave_lookup(lacp, slave_);
     if (slave) {
-	ret = true;
-	slave_get_actor(slave, &actor);
-	stats->dot3adAggPortActorSystemID = actor.sys_id;
-	stats->dot3adAggPortPartnerOperSystemID = slave->partner.sys_id;
-	stats->dot3adAggPortAttachedAggID = (lacp->key_slave->key ?
-					     lacp->key_slave->key :
-					     lacp->key_slave->port_id);
-
-	/* Construct my admin-state.  Assume aggregation is configured on. */
-	stats->dot3adAggPortActorAdminState = LACP_STATE_AGG;
-	if (lacp->active) {
-	    stats->dot3adAggPortActorAdminState |= LACP_STATE_ACT;
-	}
-	if (lacp->fast) {
-	    stats->dot3adAggPortActorAdminState |= LACP_STATE_TIME;
-	}
-	/* XXX Not sure how to know the partner admin state. It
-	 * might have to be captured and remembered during the
-	 * negotiation phase.
-	 */
-	stats->dot3adAggPortPartnerAdminState = 0;
-
-	stats->dot3adAggPortActorOperState = actor.state;
-	stats->dot3adAggPortPartnerOperState = slave->partner.state;
-
-	/* Read out the latest counters */
-	stats->dot3adAggPortStatsLACPDUsRx = slave->count_rx_pdus;
-	stats->dot3adAggPortStatsIllegalRx = slave->count_rx_pdus_bad;
-	stats->dot3adAggPortStatsLACPDUsTx = slave->count_tx_pdus;
+        ret = true;
+        slave_get_actor(slave, &actor);
+        stats->dot3adAggPortActorSystemID = actor.sys_id;
+        stats->dot3adAggPortPartnerOperSystemID = slave->partner.sys_id;
+        stats->dot3adAggPortAttachedAggID = (lacp->key_slave->key ?
+                                             lacp->key_slave->key :
+                                             lacp->key_slave->port_id);
+
+        /* Construct my admin-state.  Assume aggregation is configured on. */
+        stats->dot3adAggPortActorAdminState = LACP_STATE_AGG;
+        if (lacp->active) {
+            stats->dot3adAggPortActorAdminState |= LACP_STATE_ACT;
+        }
+        if (lacp->fast) {
+            stats->dot3adAggPortActorAdminState |= LACP_STATE_TIME;
+        }
+        /* XXX Not sure how to know the partner admin state. It
+         * might have to be captured and remembered during the
+         * negotiation phase.
+         */
+        stats->dot3adAggPortPartnerAdminState = 0;
+
+        stats->dot3adAggPortActorOperState = actor.state;
+        stats->dot3adAggPortPartnerOperState = slave->partner.state;
+
+        /* Read out the latest counters */
+        stats->dot3adAggPortStatsLACPDUsRx = slave->count_rx_pdus;
+        stats->dot3adAggPortStatsIllegalRx = slave->count_rx_pdus_bad;
+        stats->dot3adAggPortStatsLACPDUsTx = slave->count_tx_pdus;
     } else {
         ret = false;
     }
diff --git a/tests/lacp.at b/tests/lacp.at
index 7ca73db04fe8..6dd949010bdf 100644
--- a/tests/lacp.at
+++ b/tests/lacp.at
@@ -21,30 +21,30 @@ ovs-appctl time/warp 300 100
 
 AT_CHECK([ovs-appctl lacp/show], [0], [dnl
 ---- p1 ----
-	status: active negotiated
-	sys_id: aa:55:aa:55:00:00
-	sys_priority: 65535
-	aggregation key: 1
-	lacp_time: slow
+  status: active negotiated
+  sys_id: aa:55:aa:55:00:00
+  sys_priority: 65535
+  aggregation key: 1
+  lacp_time: slow
 
 slave: p1: expired attached
-	port_id: 1
-	port_priority: 65535
-	may_enable: false
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65535
-	actor port_id: 1
-	actor port_priority: 65535
-	actor key: 1
-	actor state: activity synchronized collecting distributing expired
-
-	partner sys_id: 00:00:00:00:00:00
-	partner sys_priority: 0
-	partner port_id: 0
-	partner port_priority: 0
-	partner key: 0
-	partner state: timeout
+  port_id: 1
+  port_priority: 65535
+  may_enable: false
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65535
+  actor port_id: 1
+  actor port_priority: 65535
+  actor key: 1
+  actor state: activity synchronized collecting distributing expired
+
+  partner sys_id: 00:00:00:00:00:00
+  partner sys_priority: 0
+  partner port_id: 0
+  partner port_priority: 0
+  partner key: 0
+  partner state: timeout
 ])
 AT_CHECK([ovs-appctl bond/show])
 OVS_VSWITCHD_STOP
@@ -72,49 +72,49 @@ ovs-appctl time/warp 300 100
 AT_CHECK([ovs-appctl lacp/show], [0], [stdout])
 AT_CHECK([sed -e 's/aggregation key:.*/aggregation key: <omitted>/' < stdout], [0], [dnl
 ---- bond ----
-	status: active negotiated
-	sys_id: 11:22:33:44:55:66
-	sys_priority: 54321
-	aggregation key: <omitted>
-	lacp_time: fast
+  status: active negotiated
+  sys_id: 11:22:33:44:55:66
+  sys_priority: 54321
+  aggregation key: <omitted>
+  lacp_time: fast
 
 slave: p1: expired attached
-	port_id: 11
-	port_priority: 111
-	may_enable: false
-
-	actor sys_id: 11:22:33:44:55:66
-	actor sys_priority: 54321
-	actor port_id: 11
-	actor port_priority: 111
-	actor key: 3333
-	actor state: activity timeout aggregation synchronized collecting distributing expired
-
-	partner sys_id: 00:00:00:00:00:00
-	partner sys_priority: 0
-	partner port_id: 0
-	partner port_priority: 0
-	partner key: 0
-	partner state: timeout
+  port_id: 11
+  port_priority: 111
+  may_enable: false
+
+  actor sys_id: 11:22:33:44:55:66
+  actor sys_priority: 54321
+  actor port_id: 11
+  actor port_priority: 111
+  actor key: 3333
+  actor state: activity timeout aggregation synchronized collecting distributing expired
+
+  partner sys_id: 00:00:00:00:00:00
+  partner sys_priority: 0
+  partner port_id: 0
+  partner port_priority: 0
+  partner key: 0
+  partner state: timeout
 
 slave: p2: expired attached
-	port_id: 22
-	port_priority: 222
-	may_enable: false
-
-	actor sys_id: 11:22:33:44:55:66
-	actor sys_priority: 54321
-	actor port_id: 22
-	actor port_priority: 222
-	actor key: 3333
-	actor state: activity timeout aggregation synchronized collecting distributing expired
-
-	partner sys_id: 00:00:00:00:00:00
-	partner sys_priority: 0
-	partner port_id: 0
-	partner port_priority: 0
-	partner key: 0
-	partner state: timeout
+  port_id: 22
+  port_priority: 222
+  may_enable: false
+
+  actor sys_id: 11:22:33:44:55:66
+  actor sys_priority: 54321
+  actor port_id: 22
+  actor port_priority: 222
+  actor key: 3333
+  actor state: activity timeout aggregation synchronized collecting distributing expired
+
+  partner sys_id: 00:00:00:00:00:00
+  partner sys_priority: 0
+  partner port_id: 0
+  partner port_priority: 0
+  partner key: 0
+  partner state: timeout
 ])
 AT_CHECK([ovs-appctl bond/show], [0], [dnl
 ---- bond ----
@@ -195,93 +195,93 @@ ovs-appctl bond/show bond0 | STRIP_RECIRC_ID | STRIP_ACTIVE_SLAVE_MAC
 ovs-appctl bond/show bond1 | STRIP_RECIRC_ID | STRIP_ACTIVE_SLAVE_MAC ], [0], [stdout])
 AT_CHECK([sed '/active slave/d' stdout], [0], [dnl
 ---- bond0 ----
-	status: active negotiated
-	sys_id: aa:55:aa:55:00:00
-	sys_priority: 65534
-	aggregation key: 2
-	lacp_time: fast
+  status: active negotiated
+  sys_id: aa:55:aa:55:00:00
+  sys_priority: 65534
+  aggregation key: 2
+  lacp_time: fast
 
 slave: p0: current attached
-	port_id: 1
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65534
-	actor port_id: 1
-	actor port_priority: 65535
-	actor key: 2
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:66:aa:66:00:00
-	partner sys_priority: 65534
-	partner port_id: 3
-	partner port_priority: 65535
-	partner key: 4
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 1
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65534
+  actor port_id: 1
+  actor port_priority: 65535
+  actor key: 2
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:66:aa:66:00:00
+  partner sys_priority: 65534
+  partner port_id: 3
+  partner port_priority: 65535
+  partner key: 4
+  partner state: activity timeout aggregation synchronized collecting distributing
 
 slave: p1: current attached
-	port_id: 2
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65534
-	actor port_id: 2
-	actor port_priority: 65535
-	actor key: 2
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:66:aa:66:00:00
-	partner sys_priority: 65534
-	partner port_id: 4
-	partner port_priority: 65535
-	partner key: 4
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 2
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65534
+  actor port_id: 2
+  actor port_priority: 65535
+  actor key: 2
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:66:aa:66:00:00
+  partner sys_priority: 65534
+  partner port_id: 4
+  partner port_priority: 65535
+  partner key: 4
+  partner state: activity timeout aggregation synchronized collecting distributing
 ---- bond1 ----
-	status: active negotiated
-	sys_id: aa:66:aa:66:00:00
-	sys_priority: 65534
-	aggregation key: 4
-	lacp_time: fast
+  status: active negotiated
+  sys_id: aa:66:aa:66:00:00
+  sys_priority: 65534
+  aggregation key: 4
+  lacp_time: fast
 
 slave: p2: current attached
-	port_id: 3
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:66:aa:66:00:00
-	actor sys_priority: 65534
-	actor port_id: 3
-	actor port_priority: 65535
-	actor key: 4
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:55:aa:55:00:00
-	partner sys_priority: 65534
-	partner port_id: 1
-	partner port_priority: 65535
-	partner key: 2
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 3
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:66:aa:66:00:00
+  actor sys_priority: 65534
+  actor port_id: 3
+  actor port_priority: 65535
+  actor key: 4
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:55:aa:55:00:00
+  partner sys_priority: 65534
+  partner port_id: 1
+  partner port_priority: 65535
+  partner key: 2
+  partner state: activity timeout aggregation synchronized collecting distributing
 
 slave: p3: current attached
-	port_id: 4
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:66:aa:66:00:00
-	actor sys_priority: 65534
-	actor port_id: 4
-	actor port_priority: 65535
-	actor key: 4
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:55:aa:55:00:00
-	partner sys_priority: 65534
-	partner port_id: 2
-	partner port_priority: 65535
-	partner key: 2
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 4
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:66:aa:66:00:00
+  actor sys_priority: 65534
+  actor port_id: 4
+  actor port_priority: 65535
+  actor key: 4
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:55:aa:55:00:00
+  partner sys_priority: 65534
+  partner port_id: 2
+  partner port_priority: 65535
+  partner key: 2
+  partner state: activity timeout aggregation synchronized collecting distributing
 ---- bond0 ----
 bond_mode: balance-tcp
 bond may use recirculation: yes, <del>
@@ -332,93 +332,93 @@ ovs-appctl lacp/show bond1
 ovs-appctl bond/show bond0 | STRIP_RECIRC_ID | STRIP_ACTIVE_SLAVE_MAC
 ovs-appctl bond/show bond1 | STRIP_RECIRC_ID | STRIP_ACTIVE_SLAVE_MAC ], [0], [dnl
 ---- bond0 ----
-	status: active negotiated
-	sys_id: aa:55:aa:55:00:00
-	sys_priority: 65534
-	aggregation key: 2
-	lacp_time: fast
+  status: active negotiated
+  sys_id: aa:55:aa:55:00:00
+  sys_priority: 65534
+  aggregation key: 2
+  lacp_time: fast
 
 slave: p0: expired attached
-	port_id: 1
-	port_priority: 65535
-	may_enable: false
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65534
-	actor port_id: 1
-	actor port_priority: 65535
-	actor key: 2
-	actor state: activity timeout aggregation synchronized collecting distributing expired
-
-	partner sys_id: aa:66:aa:66:00:00
-	partner sys_priority: 65534
-	partner port_id: 3
-	partner port_priority: 65535
-	partner key: 4
-	partner state: activity timeout aggregation collecting distributing
+  port_id: 1
+  port_priority: 65535
+  may_enable: false
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65534
+  actor port_id: 1
+  actor port_priority: 65535
+  actor key: 2
+  actor state: activity timeout aggregation synchronized collecting distributing expired
+
+  partner sys_id: aa:66:aa:66:00:00
+  partner sys_priority: 65534
+  partner port_id: 3
+  partner port_priority: 65535
+  partner key: 4
+  partner state: activity timeout aggregation collecting distributing
 
 slave: p1: current attached
-	port_id: 2
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65534
-	actor port_id: 2
-	actor port_priority: 65535
-	actor key: 2
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:66:aa:66:00:00
-	partner sys_priority: 65534
-	partner port_id: 4
-	partner port_priority: 65535
-	partner key: 4
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 2
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65534
+  actor port_id: 2
+  actor port_priority: 65535
+  actor key: 2
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:66:aa:66:00:00
+  partner sys_priority: 65534
+  partner port_id: 4
+  partner port_priority: 65535
+  partner key: 4
+  partner state: activity timeout aggregation synchronized collecting distributing
 ---- bond1 ----
-	status: active negotiated
-	sys_id: aa:66:aa:66:00:00
-	sys_priority: 65534
-	aggregation key: 4
-	lacp_time: fast
+  status: active negotiated
+  sys_id: aa:66:aa:66:00:00
+  sys_priority: 65534
+  aggregation key: 4
+  lacp_time: fast
 
 slave: p2: expired attached
-	port_id: 3
-	port_priority: 65535
-	may_enable: false
-
-	actor sys_id: aa:66:aa:66:00:00
-	actor sys_priority: 65534
-	actor port_id: 3
-	actor port_priority: 65535
-	actor key: 4
-	actor state: activity timeout aggregation synchronized collecting distributing expired
-
-	partner sys_id: aa:55:aa:55:00:00
-	partner sys_priority: 65534
-	partner port_id: 1
-	partner port_priority: 65535
-	partner key: 2
-	partner state: activity timeout aggregation collecting distributing
+  port_id: 3
+  port_priority: 65535
+  may_enable: false
+
+  actor sys_id: aa:66:aa:66:00:00
+  actor sys_priority: 65534
+  actor port_id: 3
+  actor port_priority: 65535
+  actor key: 4
+  actor state: activity timeout aggregation synchronized collecting distributing expired
+
+  partner sys_id: aa:55:aa:55:00:00
+  partner sys_priority: 65534
+  partner port_id: 1
+  partner port_priority: 65535
+  partner key: 2
+  partner state: activity timeout aggregation collecting distributing
 
 slave: p3: current attached
-	port_id: 4
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:66:aa:66:00:00
-	actor sys_priority: 65534
-	actor port_id: 4
-	actor port_priority: 65535
-	actor key: 4
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:55:aa:55:00:00
-	partner sys_priority: 65534
-	partner port_id: 2
-	partner port_priority: 65535
-	partner key: 2
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 4
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:66:aa:66:00:00
+  actor sys_priority: 65534
+  actor port_id: 4
+  actor port_priority: 65535
+  actor key: 4
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:55:aa:55:00:00
+  partner sys_priority: 65534
+  partner port_id: 2
+  partner port_priority: 65535
+  partner key: 2
+  partner state: activity timeout aggregation synchronized collecting distributing
 ---- bond0 ----
 bond_mode: balance-tcp
 bond may use recirculation: yes, <del>
@@ -464,93 +464,93 @@ ovs-appctl lacp/show bond1
 ovs-appctl bond/show bond0 | STRIP_RECIRC_ID | STRIP_ACTIVE_SLAVE_MAC
 ovs-appctl bond/show bond1 | STRIP_RECIRC_ID | STRIP_ACTIVE_SLAVE_MAC ], [0], [dnl
 ---- bond0 ----
-	status: active negotiated
-	sys_id: aa:55:aa:55:00:00
-	sys_priority: 65534
-	aggregation key: 2
-	lacp_time: fast
+  status: active negotiated
+  sys_id: aa:55:aa:55:00:00
+  sys_priority: 65534
+  aggregation key: 2
+  lacp_time: fast
 
 slave: p0: defaulted detached
-	port_id: 1
-	port_priority: 65535
-	may_enable: false
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65534
-	actor port_id: 1
-	actor port_priority: 65535
-	actor key: 2
-	actor state: activity timeout aggregation defaulted
-
-	partner sys_id: 00:00:00:00:00:00
-	partner sys_priority: 0
-	partner port_id: 0
-	partner port_priority: 0
-	partner key: 0
-	partner state:
+  port_id: 1
+  port_priority: 65535
+  may_enable: false
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65534
+  actor port_id: 1
+  actor port_priority: 65535
+  actor key: 2
+  actor state: activity timeout aggregation defaulted
+
+  partner sys_id: 00:00:00:00:00:00
+  partner sys_priority: 0
+  partner port_id: 0
+  partner port_priority: 0
+  partner key: 0
+  partner state:
 
 slave: p1: current attached
-	port_id: 2
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65534
-	actor port_id: 2
-	actor port_priority: 65535
-	actor key: 2
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:66:aa:66:00:00
-	partner sys_priority: 65534
-	partner port_id: 4
-	partner port_priority: 65535
-	partner key: 4
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 2
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65534
+  actor port_id: 2
+  actor port_priority: 65535
+  actor key: 2
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:66:aa:66:00:00
+  partner sys_priority: 65534
+  partner port_id: 4
+  partner port_priority: 65535
+  partner key: 4
+  partner state: activity timeout aggregation synchronized collecting distributing
 ---- bond1 ----
-	status: active negotiated
-	sys_id: aa:66:aa:66:00:00
-	sys_priority: 65534
-	aggregation key: 4
-	lacp_time: fast
+  status: active negotiated
+  sys_id: aa:66:aa:66:00:00
+  sys_priority: 65534
+  aggregation key: 4
+  lacp_time: fast
 
 slave: p2: defaulted detached
-	port_id: 3
-	port_priority: 65535
-	may_enable: false
-
-	actor sys_id: aa:66:aa:66:00:00
-	actor sys_priority: 65534
-	actor port_id: 3
-	actor port_priority: 65535
-	actor key: 4
-	actor state: activity timeout aggregation defaulted
-
-	partner sys_id: 00:00:00:00:00:00
-	partner sys_priority: 0
-	partner port_id: 0
-	partner port_priority: 0
-	partner key: 0
-	partner state:
+  port_id: 3
+  port_priority: 65535
+  may_enable: false
+
+  actor sys_id: aa:66:aa:66:00:00
+  actor sys_priority: 65534
+  actor port_id: 3
+  actor port_priority: 65535
+  actor key: 4
+  actor state: activity timeout aggregation defaulted
+
+  partner sys_id: 00:00:00:00:00:00
+  partner sys_priority: 0
+  partner port_id: 0
+  partner port_priority: 0
+  partner key: 0
+  partner state:
 
 slave: p3: current attached
-	port_id: 4
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:66:aa:66:00:00
-	actor sys_priority: 65534
-	actor port_id: 4
-	actor port_priority: 65535
-	actor key: 4
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:55:aa:55:00:00
-	partner sys_priority: 65534
-	partner port_id: 2
-	partner port_priority: 65535
-	partner key: 2
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 4
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:66:aa:66:00:00
+  actor sys_priority: 65534
+  actor port_id: 4
+  actor port_priority: 65535
+  actor key: 4
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:55:aa:55:00:00
+  partner sys_priority: 65534
+  partner port_id: 2
+  partner port_priority: 65535
+  partner key: 2
+  partner state: activity timeout aggregation synchronized collecting distributing
 ---- bond0 ----
 bond_mode: balance-tcp
 bond may use recirculation: yes, <del>
@@ -601,93 +601,93 @@ ovs-appctl lacp/show bond1
 ovs-appctl bond/show bond0 | STRIP_RECIRC_ID | STRIP_ACTIVE_SLAVE_MAC
 ovs-appctl bond/show bond1 | STRIP_RECIRC_ID | STRIP_ACTIVE_SLAVE_MAC ], [0], [dnl
 ---- bond0 ----
-	status: active negotiated
-	sys_id: aa:55:aa:55:00:00
-	sys_priority: 65534
-	aggregation key: 2
-	lacp_time: fast
+  status: active negotiated
+  sys_id: aa:55:aa:55:00:00
+  sys_priority: 65534
+  aggregation key: 2
+  lacp_time: fast
 
 slave: p0: current attached
-	port_id: 1
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65534
-	actor port_id: 1
-	actor port_priority: 65535
-	actor key: 2
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:66:aa:66:00:00
-	partner sys_priority: 65534
-	partner port_id: 3
-	partner port_priority: 65535
-	partner key: 4
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 1
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65534
+  actor port_id: 1
+  actor port_priority: 65535
+  actor key: 2
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:66:aa:66:00:00
+  partner sys_priority: 65534
+  partner port_id: 3
+  partner port_priority: 65535
+  partner key: 4
+  partner state: activity timeout aggregation synchronized collecting distributing
 
 slave: p1: current attached
-	port_id: 2
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:55:aa:55:00:00
-	actor sys_priority: 65534
-	actor port_id: 2
-	actor port_priority: 65535
-	actor key: 2
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:66:aa:66:00:00
-	partner sys_priority: 65534
-	partner port_id: 4
-	partner port_priority: 65535
-	partner key: 4
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 2
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:55:aa:55:00:00
+  actor sys_priority: 65534
+  actor port_id: 2
+  actor port_priority: 65535
+  actor key: 2
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:66:aa:66:00:00
+  partner sys_priority: 65534
+  partner port_id: 4
+  partner port_priority: 65535
+  partner key: 4
+  partner state: activity timeout aggregation synchronized collecting distributing
 ---- bond1 ----
-	status: active negotiated
-	sys_id: aa:66:aa:66:00:00
-	sys_priority: 65534
-	aggregation key: 4
-	lacp_time: fast
+  status: active negotiated
+  sys_id: aa:66:aa:66:00:00
+  sys_priority: 65534
+  aggregation key: 4
+  lacp_time: fast
 
 slave: p2: current attached
-	port_id: 3
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:66:aa:66:00:00
-	actor sys_priority: 65534
-	actor port_id: 3
-	actor port_priority: 65535
-	actor key: 4
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:55:aa:55:00:00
-	partner sys_priority: 65534
-	partner port_id: 1
-	partner port_priority: 65535
-	partner key: 2
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 3
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:66:aa:66:00:00
+  actor sys_priority: 65534
+  actor port_id: 3
+  actor port_priority: 65535
+  actor key: 4
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:55:aa:55:00:00
+  partner sys_priority: 65534
+  partner port_id: 1
+  partner port_priority: 65535
+  partner key: 2
+  partner state: activity timeout aggregation synchronized collecting distributing
 
 slave: p3: current attached
-	port_id: 4
-	port_priority: 65535
-	may_enable: true
-
-	actor sys_id: aa:66:aa:66:00:00
-	actor sys_priority: 65534
-	actor port_id: 4
-	actor port_priority: 65535
-	actor key: 4
-	actor state: activity timeout aggregation synchronized collecting distributing
-
-	partner sys_id: aa:55:aa:55:00:00
-	partner sys_priority: 65534
-	partner port_id: 2
-	partner port_priority: 65535
-	partner key: 2
-	partner state: activity timeout aggregation synchronized collecting distributing
+  port_id: 4
+  port_priority: 65535
+  may_enable: true
+
+  actor sys_id: aa:66:aa:66:00:00
+  actor sys_priority: 65534
+  actor port_id: 4
+  actor port_priority: 65535
+  actor key: 4
+  actor state: activity timeout aggregation synchronized collecting distributing
+
+  partner sys_id: aa:55:aa:55:00:00
+  partner sys_priority: 65534
+  partner port_id: 2
+  partner port_priority: 65535
+  partner key: 2
+  partner state: activity timeout aggregation synchronized collecting distributing
 ---- bond0 ----
 bond_mode: balance-tcp
 bond may use recirculation: yes, <del>